local spells = {
  --ENGINEERING/PROFESSION ITEMS		
		[67826] = true, -- Jeeves
        [54711] = true, -- Scrapbot
        [22700] = true, -- Field Repair Bot 74A
        [44389] = true, -- Field Repair Bot 110G
		[127129] = true, -- Blingtron 4000
		[126459] = true, -- Blingtron 4000
        [54710] = true, -- MOLL-E
		[126462] = true, -- Thermal Anvil
		[67833] = false, -- Wormhole Generator: Northrend
		[126755] = false, -- Wormhole Generator: Pandaria

  --SPELLS
        [92824] = true, -- Ritual of Refreshment
        [43987] = true, -- Refreshment Portal
        [698] = true, --   Ritual of Summoning
        [29893] = true, -- Ritual of Souls
		[126135] = true, -- Lightwell
		[724] = true, -- Lightwell (Glyphed)
		[115315] = false, -- Summon Black Ox Statue**
		[115313] = false, -- Summon Jade Serpent Statue**  
		
  --MOUNTS		
		[61425] = false, -- Traveler's Tundra Mammoth (Alliance)
		[61447] = false, -- Traveler's Tundra Mammoth (Horde)
		[122708] = false, -- Grand Expedition Yak
		[75973] = false, -- X-53 Touring Rocket		
		[60866] = false, -- Mechano Hog
		[60867] = false, -- Mekgineer's Chopper	

  --GUILD MISC				
		[83958] = true, -- Mobile Banking
		[92396] = true, -- Guild Page (Horde)
		[92395] = true, -- Guild Page (Alliance)
		[92398] = true, -- Guild Herald (Horde)
		[92397] = true, -- Guild Herald (Alliance)	
		[90633] = true, -- Battle Standard of Coordination
		[90631] = true, -- Battle Standard of Coordination		
		
  --VANITY/TCG ITEMS/MISC		
		[42753] = true, -- Goblin Gumbo Kettle
		[45103] = true, -- Romantic Picnic Basket
		[148627] = false, -- Warped Warning Sign	
		[127320] = false, -- Magic Banana
		[116485] = false, -- The Golden Banana
		[116484] = false, -- The Golden Banana
		[62857] = false, -- Sandbox Tiger
		[125167] = false, -- Ancient Pandaren Fishing Charm
		[145430] = false, -- Call of the Mists
		[61243] = false, -- Parachute
		[148538] = false, -- Blackflame Daggers
		[46168] = false, -- Pet Biscuit	
		[51510] = false, -- Party G.R.E.N.A.D.E.
		[60458] = false, -- Toss Your Luck!
			
  --CAULDRONS			
        [92649] = true, -- Cauldron of Battle
        [92712] = true, -- Big Cauldron of Battle
		[41458] = true, -- Cauldron of Major Arcane Protection
        [41500] = true, -- Cauldron of Major Fire Protection
        [41501] = true, -- Cauldron of Major Frost Protection

  --FEASTS/BANQUETS/NOODLE CARTS     
        [104958] = true, -- Pandaren Banquet
        [126492] = true, -- Banquet of the Grill
        [126494] = true, -- Great Banquet of the Grill
        [126501] = true, -- Banquet of the Oven
        [126502] = true, -- Great Banquet of the Oven
        [126504] = true, -- Great Banquet of the Brew
        [126498] = true, -- Great Banquet of the Pot
        [126500] = true, -- Great Banquet of the Steamer
        [126496] = true, -- Great Banquet of the Wok
        [105193] = true, -- Great Pandaren Banquet
        [126503] = true, -- Banquet of the Brew
        [126497] = true, -- Banquet of the Pot
        [126499] = true, -- Banquet of the Steamer
        [126495] = true, -- Banquet of the Wok
		[87915] = true, -- Goblin Barbecue Feast
		[87916] = true, -- Goblin Barbecue Feast
        [87644] = true, -- Seafood Magnifique Feast
        [87643] = true, -- Broiled Dragon Feast     
        [146936] = true, -- Noodle Cart
		[146933] = true, -- Noodle Cart
        [146937] = true, -- Deluxe Noodle Cart
		[145169] = true, -- Deluxe Noodle Cart		
        [146938] = true, -- Pandaren Treasure Noodle Cart
		[57426] = true, -- Fish Feast
        [57301] = true, -- Great Feast
        [175215] = true, -- Savage Feast
		[160914] = true, -- Feast of the Waters
		[173978] = true, -- Feast of Blood
		
  --SUMMONING STONE PORTAL (NOT WORKING)
		[23598] = false, -- Meeting Stone Summon
		
  --MAGE PORTALS     
        [10059] = true, -- STORMWIND PORTAL
        [11416] = true, -- IRONFORGE PORTAL
        [11417] = true, -- ORGRIMMAR PORTAL
        [11418] = true, -- UNDERCITY PORTAL
        [11419] = true, -- DARNASSUS PORTAL
        [11420] = true, -- THUNDER BLUFF PORTAL
        [32266] = true, -- EXODAR PORTAL
        [32267] = true, -- SILVERMOON PORTAL
        [33691] = true, -- SHATTRATH PORTAL
        [35717] = true, -- SHATTRATH PORTAL
        [49360] = true, -- THERAMORE PORTAL
        [49361] = true, -- STONARD PORTAL
        [53142] = true, -- DALARAN PORTAL
        [88345] = true, -- TOL BARAD PORTAL
        [88346] = true, -- TOL BARAD PORTAL
        [120146] = true, -- ANCIENT DALARAN PORTAL
        [132620] = true, -- VALE OF ETERNAL BLOSSOMS PORTAL
        [132626] = true, -- VALE OF ETERNAL BLOSSOMS PORTAL
}

local MESSAGE_TEMPLATE = "{rt1} %s has created %s {rt1}"
local db
local lastAnnounced = {}
local Addon = CreateFrame("Frame", "ConjuredAnnouncer")
Addon:SetScript("OnEvent", function(self, event, ...) return self[event](self, ...) end)
Addon:RegisterEvent("ADDON_LOADED")
Addon:RegisterEvent("GROUP_ROSTER_UPDATE")


function Addon:print(message)
	DEFAULT_CHAT_FRAME:AddMessage("|cff7f7fff[Conjured Announcer]|r " .. message)
end


function Addon:isPlayerALeader()
	return UnitIsGroupLeader("player") or UnitIsGroupAssistant("player")
end


function Addon:getChatChannel()
	local channel
	if db.raidWarning and IsInRaid() and (UnitIsGroupLeader("player") or UnitIsGroupAssistant("player")) then
		channel = "RAID_WARNING"
	elseif ( IsInGroup(LE_PARTY_CATEGORY_INSTANCE) ) then
		channel = "INSTANCE_CHAT"
	elseif ( IsInRaid() and not db.partyInRaid ) then
		channel = "RAID"
	elseif ( IsInGroup() ) then
		channel = "PARTY"
	end
	return channel
end


function Addon:announceSpell(spellID, casterName, casterServer)
	local fullName = casterName .. "-" .. (casterServer or "")
	lastAnnounced[fullName] = lastAnnounced[fullName] or {}
	local now = GetTime()
	local lastTime = lastAnnounced[fullName][spellID]
	if ( lastTime ~= nil and (now - lastTime) < 5 ) then return end
	lastAnnounced[fullName][spellID] = now
	
	local spellLink = GetSpellLink(spellID)
	local spellName = GetSpellInfo(spellID)
	local message = format(MESSAGE_TEMPLATE, casterName, (spellLink or spellName))
	local channel = self:getChatChannel()
	SendChatMessage(message, channel)
end


 -- events

 
function Addon:ADDON_LOADED(name)
	if ( name ~= "ConjuredAnnouncer" ) then return end
	if ( ConjuredAnnouncerDB == nil ) then
		ConjuredAnnouncerDB = {
			enabled = true,
			partyInRaid = false,
			raidWarning = true,
		}
		self:print("Welcome! Type /can for options.")
	end
	db = ConjuredAnnouncerDB
end


function Addon:GROUP_ROSTER_UPDATE()
	if ( db.enabled and IsInGroup() ) then
		self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	else
		self:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		lastAnnounced = {}
	end
end


function Addon:UNIT_SPELLCAST_SUCCEEDED(unitID, _, _, _, spellID)
	if ( not spells[spellID] ) then return end
	local name, server = UnitName(unitID)
	self:announceSpell(spellID, name, server)
end


-- slash commands


SLASH_CONJUREDANNOUNCER1 = "/can"
local ON = "|cff7fff7fON|"
local OFF = "|cff7f7f7fOFF|r"


SlashCmdList["CONJUREDANNOUNCER"] = function(input)
	local command, args = strsplit(" ", input or "", 2)
	command = strlower(command)

	if command == "off" then
		db.enabled = false
		Addon:GROUP_ROSTER_UPDATE()
		Addon:print("Announcements " .. OFF .. ". Type '/can on' to enable.")
	elseif command == "on" then
		db.enabled = true
		Addon:GROUP_ROSTER_UPDATE()
		Addon:print("Announcements " .. ON ..". Type '/can off' to disable.")
	elseif command == "party" then
		db.partyInRaid = not db.partyInRaid
		Addon:print("Now announcing to " .. (db.partyInRaid and "|cFF87CEFA/party only|r" or "|cffff0000/ra|r") .. " while in a raid group.")
	elseif command == "rw" then
		db.raidWarning = not db.raidWarning
		Addon:print("Raid warning announcements " .. (db.raidWarning and ON or OFF))
	else
		Addon:print("Current state is " .. (db.enabled and ON or OFF))
		print("    Use /can with the following commands:")
		print("  |cffffff7f on |r- enable announcements")
		print("  |cffffff7f off |r- disable announcements")
		print("  |cffffff7f party |r- announce only to |cFF87CEFAparty|r in a raid (" .. (db.partyInRaid and ON or OFF) .. ")")
		print("  |cffffff7f rw |r- announce to raid warning when possible (" .. (db.raidWarning and ON or OFF) .. ")")
		print("  |cffffff7f /can |r- shows this list of commands")
	end
end